@echo off


IF NOT EXIST "MSound.aaf" (
  goto FAILNOFILE
)

IF EXIST "__backup/MSound.aaf" (
  goto FAIL
)




:PACK
mkdir "./__backup"
mkdir "./__backup/Banks"
mkdir "./__backup/Seqs"
copy "./MSound.aaf" "./__backup/" > NUL
copy "./Banks" "./__backup/Banks" > NUL
echo Unpacking AAF....
"%CD%/tool/jampacked.exe" unpack MSound.aaf Audio_Modding
"%CD%/tool/wsystool.exe" unpack "./Audio_Modding/include/0.wsy" "./Audio_Modding/0" -awpath "%CD%/Banks/" -waveout "./Audio_Modding/0/extracted_waves"
"%CD%/tool/wsystool.exe" unpack "./Audio_Modding/include/1.wsy" "./Audio_Modding/1" -awpath "%CD%/Banks/" -waveout "./Audio_Modding/1/extracted_waves"
"%CD%/tool/wsystool.exe" unpack "./Audio_Modding/include/2.wsy" "./Audio_Modding/2" -awpath "%CD%/Banks/" -waveout "./Audio_Modding/2/extracted_waves"


echo Unpacking IBNK

"%CD%/tool/ibnktool.exe" unpack "./Audio_Modding/include/0.bnk" "./Audio_Modding/IBNK0"
"%CD%/tool/ibnktool.exe" unpack "./Audio_Modding/include/1.bnk" "./Audio_Modding/IBNK1"
"%CD%/tool/ibnktool.exe" unpack "./Audio_Modding/include/2.bnk" "./Audio_Modding/IBNK2"
"%CD%/tool/ibnktool.exe" unpack "./Audio_Modding/include/3.bnk" "./Audio_Modding/IBNK3"
"%CD%/tool/ibnktool.exe" unpack "./Audio_Modding/include/4.bnk" "./Audio_Modding/IBNK4"
"%CD%/tool/ibnktool.exe" unpack "./Audio_Modding/include/5.bnk" "./Audio_Modding/IBNK5"
"%CD%/tool/ibnktool.exe" unpack "./Audio_Modding/include/6.bnk" "./Audio_Modding/IBNK6"
"%CD%/tool/ibnktool.exe" unpack "./Audio_Modding/include/7.bnk" "./Audio_Modding/IBNK7"
"%CD%/tool/ibnktool.exe" unpack "./Audio_Modding/include/8.bnk" "./Audio_Modding/IBNK8"
"%CD%/tool/ibnktool.exe" unpack "./Audio_Modding/include/9.bnk" "./Audio_Modding/IBNK9"
"%CD%/tool/ibnktool.exe" unpack "./Audio_Modding/include/10.bnk" "./Audio_Modding/IBNK10"
"%CD%/tool/ibnktool.exe" unpack "./Audio_Modding/include/11.bnk" "./Audio_Modding/IBNK11"
"%CD%/tool/ibnktool.exe" unpack "./Audio_Modding/include/12.bnk" "./Audio_Modding/IBNK12"

echo Transforming ASN...
"%CD%/tool/asn2csv.exe" "msound.asn" "./Audio_Modding/ASN.csv"
move ./mSound.csv ./Audio_Modding > NUL 

echo Unpacking sequence BARC. 
"%CD%/tool/barctool.exe" unpack "./Audio_Modding/include/1.arc" "./Audio_Modding/Sequences" -arc "./Seqs/"

echo Unpacking BST 
"%CD%/tool/bast" unpack "./Audio_Modding/include/0.bst" "./Audio_Modding/SoundTable"



GOTO EOF 

:FAILNOFILE
echo Heck!
echo You need to extract your "mSound.aaf" from the nintendo.szs and place it in this folder. 
echo %CD%
GOTO EOF

:FAIL
echo WARNING: You already have a backup. If you make a backup now, and have made any changes, this will corrupt the backup of your original game files.
echo Choose wisely.
SET /P AREYOUSURE=No regrets, mister freeman: (Y/[N])
IF /I "%AREYOUSURE%" EQU "Y" GOTO PACK

:EOF
pause